unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, StdCtrls, Unit4, Unit2;

type

  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    IDS:array of TID;
    CountId:Integer;
    Rodosoub:Text;//soubor nacitaci
  public
    Persons:TList;
    Function Zarad(ID:String; Zmena:Boolean):Boolean;
    Procedure PridejPerson(Person:Tperson);
    Procedure SmazKdyz(ID:TID);
  end;

var
  Form1: TForm1;

implementation

uses Unit3;

var XPom, YPom, ZPom:Integer;//pomocna promena

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Zadej:=TZadej.Create(Application);
  Zadej.ShowModal;
end;

Function TForm1.Zarad;//proti vice stejnym ID
begin
  Result:=True;
  if Zmena=false then exit;
  For XPom:=0 to CountId-1 do if ID=IDS[XPom] then Result:=False;
  if Result then
  begin
    CountId:=CountId+1;
    SetLength(IDS,CountId);
    IDS[CountId-1]:=ID;
  end else ShowMessage('Id pouzit jen jednou');
end;

Procedure TForm1.PridejPerson;
begin
  Persons.Add(TFrame2.Create(Application));
  with TFrame2(Persons[Persons.Count-1]) do
  begin
    Parent:=Form1;
    TFrame2(Persons[Persons.Count-1]).Tag:=Persons.Count;//pro rychlejsi nalezeni pri vstupu
    Name:=Person.Id;
    ID.Caption:=Person.ID;
    Jmeno.Caption:=Person.Jmeno;
    Prijmeni.Caption:=Person.Prijmeni;
    if Person.Pohlavi_M then Pohlavi.Caption:='Mu' else Pohlavi.Caption:='ena';
    Narozeni.Caption:=IntToStr(Person.Narozeni);
    Umrti.Caption:=IntToStr(Person.Umrti);
    Matka.Caption:=Person.Matka;
    Otec.Caption:=Person.Otec;
    If Person.Pohlavi_M then ComboBox1.Items.Add(Person.ID) else ComboBox2.Items.Add(Person.ID);
    //Rozdeli do otco/matek, pri vytvoreni form3 nacte
    if (Otec.Caption='') and (Matka.Caption='') then Top:=ToolBar1.Height else//pokud nema predky, az nahoru
    begin
      For XPom:=0 to Persons.Count-1 do
        if (TFrame2(Persons.Items[XPom]).Id.Caption=Otec.Caption) or (TFrame2(Persons.Items[XPom]).Id.Caption=Matka.Caption) then
        begin
          Top:=TFrame2(Persons.Items[XPom]).Top+150;//vyska frame2 a kousek mezera, umisti pod odce/matku
          Break;//uz neni treba hledat
        end;
    end;
    YPom:=0;
    For XPom:=0 to Persons.Count-2 do//pocitet jen s ostatnima
    begin
      if (TFrame(Persons.Items[XPom]).Top=TFrame(Persons.items[Persons.Count-1]).Top) then YPom:=YPom+1;//zjesti kolikaty je v radku
    end;
    Left:=10+130*ypom//mezery, posun podle sirky predchozich
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Persons.Destroy;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Persons:=TList.Create;
end;

procedure TForm1.Button2Click(Sender: TObject);
var ID:TID;
begin
  YPom:=-1;
  For XPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[Xpom]).color=clred then YPom:=Xpom;//najde oznacene
  if (YPom>-1) and (MessageDlg('Opravdu odstranit osobu'+#13+TFrame2(Persons.Items[YPom]).Id.Caption,
  MTConfirmation,[MBOK,MBCancel],0)=MROk) then
  begin
    ID:=TFrame2(Persons.Items[YPom]).ID.Caption;
    TFrame2(Persons.Items[YPom]).Destroy;
    Persons.Delete(YPom);
    For XPom:=0 to Persons.Count-1 do if (ID=TFRame2(Persons.Items[XPom]).Matka.Caption) then TFRame2(Persons.Items[XPom]).Matka.Caption:='';
    For XPom:=0 to Persons.Count-1 do if (ID=TFRame2(Persons.Items[XPom]).otec.Caption) then TFRame2(Persons.Items[XPom]).otec.Caption:='';
    FormPaint(Nil);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  YPom:=-1;
  For XPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[Xpom]).color=clred then YPom:=Xpom;//najde oznacene
  with TFrame2(Persons.Items[YPom]) do
  begin
    Zadej:=TZadej.Create(Application);
    Zadej.id.Text:=Id.Caption;
    Zadej.id.Enabled:=False;
    Zadej.prijmeni.Text:=Prijmeni.Caption;
    Zadej.jmeno.Text:=Jmeno.Caption;
    Zadej.pohlavi.Text:=Pohlavi.Caption;
    Zadej.narozeni.Value:=StrToInt(Narozeni.Caption);
    Zadej.umrti.Value:=StrToInt(Umrti.Caption);
    Zadej.matka.Text:=Matka.Caption;
    Zadej.otec.Text:=Otec.Caption;
    Zadej.ShowModal;
  end;
end;

Procedure TForm1.SmazKdyz;
begin
  YPom:=-1;
  For XPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[Xpom]).Id.caption=Id then YPom:=Xpom;
  if YPom>-1 then
  begin
    ID:=TFrame2(Persons.Items[YPom]).ID.Caption;
    TFrame2(Persons.Items[YPom]).Destroy;
    Persons.Delete(YPom);
    For XPom:=0 to Persons.Count-1 do if (ID=TFRame2(Persons.Items[XPom]).Matka.Caption) then TFRame2(Persons.Items[XPom]).Matka.Caption:='';
    For XPom:=0 to Persons.Count-1 do if (ID=TFRame2(Persons.Items[XPom]).otec.Caption) then TFRame2(Persons.Items[XPom]).otec.Caption:='';
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
Var Mat,Ot:TID;
begin
  Screen.Cursor:=CRHourGlass;
  For XPom:=1 to Persons.Count-1 do
  begin
    Mat:='';
    Ot:='';
    if TFrame2(Persons.Items[XPom]).Matka.Caption<>'' then Mat:=TFrame2(Persons.Items[XPom]).Matka.Caption;
    if TFrame2(Persons.Items[XPom]).otec.Caption<>'' then ot:=TFrame2(Persons.Items[XPom]).otec.Caption;
    if (Mat<>'') and (Ot<>'') then
    begin
      Canvas.Pen.Color:=CLRed;
      Canvas.Pen.Width:=3;
      For YPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[YPom]).Id.Caption=Mat then Canvas.MoveTo(TFrame2(Persons.Items[YPom]).Left+55,TFrame2(Persons.Items[YPom]).Top+60);
      For YPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[YPom]).Id.Caption=ot then Canvas.LineTo(TFrame2(Persons.Items[YPom]).Left+55,TFrame2(Persons.Items[YPom]).Top+60);//spoji carou matku a otce
    end;
    if Mat<>'' then
    begin
      Canvas.Pen.Color:=CLBlue;
      Canvas.Pen.Width:=2;
      For YPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[YPom]).Id.Caption=Mat then Canvas.MoveTo(TFrame2(Persons.Items[YPom]).Left+55,TFrame2(Persons.Items[YPom]).Top+60);
      Canvas.LineTo(TFrame2(Persons.Items[XPom]).Left+55,TFrame2(Persons.Items[XPom]).Top+60);
    end;
    if ot<>'' then
    begin
      Canvas.Pen.Color:=CLGreen;
      Canvas.Pen.Width:=2;
      For YPom:=0 to Persons.Count-1 do if TFrame2(Persons.Items[YPom]).Id.Caption=ot then Canvas.MoveTo(TFrame2(Persons.Items[YPom]).Left+55,TFrame2(Persons.Items[YPom]).Top+60);
      Canvas.LineTo(TFrame2(Persons.Items[XPom]).Left+55,TFrame2(Persons.Items[XPom]).Top+60);
    end;
  end;
  Screen.Cursor:=CRDefault;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  rete:string;//jeko retezec
  Znak:Char;
  Kde:String;
  Uzavreno:boolean;
begin
  if ((Persons.Count=0) or (MessageDlg('Muze se stat, ze bude stejne id'+
   #13+'Pokracovat?',mtwarning,[mbok,mbcancel],0)=mrok)) and OpenDialog1.Execute then
  begin
    Screen.Cursor:=CRHourGlass;
    AssignFile(RodoSoub,OpenDialog1.FileName);
    Reset(RodoSoub);
    While Not EOf(RodoSoub) do
    begin
      Read(RodoSoub,Znak);
      if (Znak<>'<') and (Znak<>'>') then  if uzavreno then rete:=Rete+Znak else Kde:=Kde+Znak
      else
      begin
        if Znak='<' then
        begin
          Uzavreno:=False;
          if Kde='id' then
          begin
            if Zarad(Rete,true) then
            begin
              TFrame2(Persons.Items[Persons.Count-1]).ID.Caption:=Rete;
              TFrame2(Persons.Items[Persons.Count-1]).Name:=Rete;
            end;
          end;
          if kde='jmeno' then TFrame2(Persons.Items[Persons.Count-1]).Jmeno.Caption:=Rete;
          if kde='prijmeni' then TFrame2(Persons.Items[Persons.Count-1]).prijmeni.Caption:=Rete;
          if kde='pohlavi' then if rete='M' then TFrame2(Persons.Items[Persons.Count-1]).Pohlavi.Caption:='Mu' else TFrame2(Persons.Items[Persons.Count-1]).Pohlavi.Caption:='ena';
          if kde='narozeni' then TFrame2(Persons.Items[Persons.Count-1]).narozeni.Caption:=Rete;
          if kde='otec' then TFrame2(Persons.Items[Persons.Count-1]).otec.Caption:=Rete;
          if kde='matka' then TFrame2(Persons.Items[Persons.Count-1]).matka.Caption:=Rete;
          Rete:='';
          Kde:='';
        end else
        begin
          if Kde[1]='/' then Kde:='';
          if Kde='osoba' then Persons.Add(TFrame2.Create(Application));
          Rete:='';
          Uzavreno:=True;
        end;
      end;
    end;
    For XPom:=0 to Persons.Count-1 do
    begin
      TFrame2(Persons.Items[XPom]).Parent:=Form1;
      If TFrame2(Persons.Items[XPom]).Pohlavi.Caption='Mu' then ComboBox1.Items.Add(TFrame2(Persons.Items[XPom]).ID.caption) else ComboBox2.Items.Add(TFrame2(Persons.Items[XPom]).ID.caption);
      //Rozdeli do otco/matek, pri vytvoreni form3 nacte
      if (TFrame2(Persons.Items[XPom]).Otec.Caption='') and (TFrame2(Persons.Items[XPom]).Matka.Caption='') then Top:=ToolBar1.Height else//pokud nema predky, az nahoru
      begin
      For YPom:=0 to Persons.Count-1 do
        if (TFrame2(Persons.Items[YPom]).Id.Caption=TFrame2(Persons.Items[XPom]).Otec.Caption) or (TFrame2(Persons.Items[YPom]).Id.Caption=TFrame2(Persons.Items[XPom]).Matka.Caption) then
        begin
          TFrame2(Persons.Items[XPom]).Top:=TFrame2(Persons.Items[YPom]).Top+150;//vyska frame2 a kousek mezera, umisti pod odce/matku
          Break;//uz neni treba hledat
        end;
      if TFrame(Persons.Items[XPom]).Top<=Toolbar1.Height then TFrame2(Persons.Items[XPom]).Top:=Toolbar1.Height;
    end;
    ZPom:=0;
    For YPom:=0 to XPom do if YPom<>XPom then//pocitet jen s ostatnima
    begin
      if (TFrame(Persons.Items[YPom]).Top=TFrame(Persons.items[XPom]).Top) then ZPom:=ZPom+1;//zjesti kolikaty je v radku
      end;
        TFrame2(Persons.Items[XPom]).Left:=10+130*Zpom//mezery, posun podle sirky predchozich
      end;
      For XPom:=0 to Persons.Count-1 do TFrame(Persons.Items[XPom]).Top:=TFrame(Persons.Items[XPom]).Top+Toolbar1.Height;//nekdy se to prekryva s horni listou-zamezeni
      FormPaint(Nil);
      Screen.Cursor:=CRDefault;
  end;
end;

end.
